<template>
  <div class="app-container">
    <el-row>
      <el-select v-model="oneTierMenu" placeholder="第一層目錄" @change="getChildrenMenu(1)">
        <el-option v-for="(i,index) in oneTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
    </el-row>
    <el-row>
      <el-select v-model="twoTierMenu" placeholder="第二層目錄" @change="getChildrenMenu(2)">
        <el-option v-for="(i,index) in twoTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
    </el-row>
    <el-row>
      <el-select v-model="threeTierMenu" placeholder="第三層目錄" @change="getChildrenMenu(3)">
        <el-option v-for="(i,index) in threeTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
    </el-row>
    <el-row>
      <el-select v-model="fourTierMenu" placeholder="第四層目錄">
        <el-option v-for="(i,index) in fourTierMenus" :key="index" :label="i.title" :value="i.id" />
      </el-select>
      <el-button @click="updateAction">設定REDIRECT</el-button>
      <el-button>重置</el-button>
    </el-row>
  </div>
</template>
<script>
import { getOneTierMenu, getMenuByParent, updateRedirect } from './action'
export default {
  data() {
    return {
      oneTierMenus: [],
      twoTierMenus: [],
      threeTierMenus: [],
      fourTierMenus: [],
      oneTierMenu: '',
      twoTierMenu: '',
      threeTierMenu: '',
      fourTierMenu: ''
    }
  },
  mounted() {
    this.getOneTierMenu()
  },
  methods: {
    updateAction: function() {
      if (this.twoTierMenu.length === 0 || this.fourTierMenu.length === 0) {
        alert('請選擇目錄!')
        return
      }

      updateRedirect({
        id: this.twoTierMenu,
        redirect: this.fourTierMenu
      }).then(res => {
        if (res.status === 'OK') {
          alert('更新成功!')
        } else {
          alert('更新失敗!')
        }
      })
    },
    getOneTierMenu: function() {
      getOneTierMenu().then(res => {
        if (res.status === 'OK') {
          this.oneTierMenus = res.data
        }
      })
    },
    getChildrenMenu: function(val) {
      if (val === 1) {
        this.twoTierMenus = []
        this.twoTierMenu = ''
        this.threeTierMenus = []
        this.threeTierMenu = ''
        this.fourTierMenus = []
        this.fourTierMenu = ''
        getMenuByParent({ parent: this.oneTierMenu, tier: 1 }).then(res => {
          if (res.status === 'OK') {
            this.twoTierMenus = res.data
          }
        })
      } else if (val === 2) {
        getMenuByParent({ parent: this.twoTierMenu, tier: 2 }).then(res => {
          this.threeTierMenus = []
          this.threeTierMenu = ''
          if (res.status === 'OK') {
            this.threeTierMenus = res.data
          }
        })
      } else if (val === 3) {
        getMenuByParent({ parent: this.threeTierMenu, tier: 3 }).then(res => {
          this.fourTierMenus = []
          this.fourTierMenu = ''
          if (res.status === 'OK') {
            this.fourTierMenus = res.data
          }
        })
      }
    }
  }
}
</script>

